function plot_plate(x_val, y_val, R, r, R_val, a, n_p)

    import casadi.*

    figure
    hold on;

    for i = 1:n_p

        plot_circle(x_val(i), y_val(i), R, r, R_val, i);
        plot_center(x_val(i), y_val(i), i);
        
    end
    
    xlim([0, a]);
    ylim([0, a]);
    
    xlabel('x');
    ylabel('y');
    
    grid('on');
    
end

function [r_c_eval] = get_radius_from_index(R, r, R_val, i)

    import casadi.*

    r_i = r(i);
    r_fcn = Function('r_fcn', {R}, {r_i});
    
    r_c_eval = full(r_fcn(R_val));

end
   

function plot_circle(x_i, y_i, R, r, R_val, i)

    import casadi.*

    eps = 1e-8;
    
    r_i = get_radius_from_index(R, r, R_val, i);
        
    X = linspace(x_i-r_i, x_i+r_i, 100);

    Y_pos = sqrt(r_i.^2 - (X - x_i).^2 + eps)+y_i;
    Y_neg = -sqrt(r_i.^2 - (X - x_i).^2 + eps)+y_i;

    plot(X, Y_pos, 'b');
	plot(X, Y_neg, 'b');

end


function plot_center(x_i, y_i, i)

    import casadi.*

    eps = 1e-8;
    
    scatter(x_i, y_i, 'b', 'x');
    t = text(x_i + 0.2, y_i + 0.2, ['s_', num2str(i)]);
    
end
